// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from kompass_interfaces:action/PlanPath.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__ACTION__DETAIL__PLAN_PATH__STRUCT_H_
#define KOMPASS_INTERFACES__ACTION__DETAIL__PLAN_PATH__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'goal'
#include "geometry_msgs/msg/detail/pose__struct.h"
// Member 'algorithm_name'
#include "rosidl_runtime_c/string.h"
// Member 'end_tolerance'
#include "kompass_interfaces/msg/detail/path_tracking_error__struct.h"

/// Struct defined in action/PlanPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__PlanPath_Goal
{
  geometry_msgs__msg__Pose goal;
  /// Name of the planning algorithm to be used
  rosidl_runtime_c__String algorithm_name;
  /// tolerance for end goal - keep planning until location error is within tolerance
  kompass_interfaces__msg__PathTrackingError end_tolerance;
} kompass_interfaces__action__PlanPath_Goal;

// Struct for a sequence of kompass_interfaces__action__PlanPath_Goal.
typedef struct kompass_interfaces__action__PlanPath_Goal__Sequence
{
  kompass_interfaces__action__PlanPath_Goal * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__PlanPath_Goal__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'end_displacement'
// already included above
// #include "kompass_interfaces/msg/detail/path_tracking_error__struct.h"

/// Struct defined in action/PlanPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__PlanPath_Result
{
  /// Error between end location and goal location
  kompass_interfaces__msg__PathTrackingError end_displacement;
  /// If goal location is reached within given tolerance
  bool reached_end;
} kompass_interfaces__action__PlanPath_Result;

// Struct for a sequence of kompass_interfaces__action__PlanPath_Result.
typedef struct kompass_interfaces__action__PlanPath_Result__Sequence
{
  kompass_interfaces__action__PlanPath_Result * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__PlanPath_Result__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'plan'
#include "nav_msgs/msg/detail/path__struct.h"

/// Struct defined in action/PlanPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__PlanPath_Feedback
{
  /// Path from current location to goal
  nav_msgs__msg__Path plan;
} kompass_interfaces__action__PlanPath_Feedback;

// Struct for a sequence of kompass_interfaces__action__PlanPath_Feedback.
typedef struct kompass_interfaces__action__PlanPath_Feedback__Sequence
{
  kompass_interfaces__action__PlanPath_Feedback * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__PlanPath_Feedback__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'goal'
#include "kompass_interfaces/action/detail/plan_path__struct.h"

/// Struct defined in action/PlanPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__PlanPath_SendGoal_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
  kompass_interfaces__action__PlanPath_Goal goal;
} kompass_interfaces__action__PlanPath_SendGoal_Request;

// Struct for a sequence of kompass_interfaces__action__PlanPath_SendGoal_Request.
typedef struct kompass_interfaces__action__PlanPath_SendGoal_Request__Sequence
{
  kompass_interfaces__action__PlanPath_SendGoal_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__PlanPath_SendGoal_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"

/// Struct defined in action/PlanPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__PlanPath_SendGoal_Response
{
  bool accepted;
  builtin_interfaces__msg__Time stamp;
} kompass_interfaces__action__PlanPath_SendGoal_Response;

// Struct for a sequence of kompass_interfaces__action__PlanPath_SendGoal_Response.
typedef struct kompass_interfaces__action__PlanPath_SendGoal_Response__Sequence
{
  kompass_interfaces__action__PlanPath_SendGoal_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__PlanPath_SendGoal_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"

/// Struct defined in action/PlanPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__PlanPath_GetResult_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
} kompass_interfaces__action__PlanPath_GetResult_Request;

// Struct for a sequence of kompass_interfaces__action__PlanPath_GetResult_Request.
typedef struct kompass_interfaces__action__PlanPath_GetResult_Request__Sequence
{
  kompass_interfaces__action__PlanPath_GetResult_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__PlanPath_GetResult_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'result'
// already included above
// #include "kompass_interfaces/action/detail/plan_path__struct.h"

/// Struct defined in action/PlanPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__PlanPath_GetResult_Response
{
  int8_t status;
  kompass_interfaces__action__PlanPath_Result result;
} kompass_interfaces__action__PlanPath_GetResult_Response;

// Struct for a sequence of kompass_interfaces__action__PlanPath_GetResult_Response.
typedef struct kompass_interfaces__action__PlanPath_GetResult_Response__Sequence
{
  kompass_interfaces__action__PlanPath_GetResult_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__PlanPath_GetResult_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'feedback'
// already included above
// #include "kompass_interfaces/action/detail/plan_path__struct.h"

/// Struct defined in action/PlanPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__PlanPath_FeedbackMessage
{
  unique_identifier_msgs__msg__UUID goal_id;
  kompass_interfaces__action__PlanPath_Feedback feedback;
} kompass_interfaces__action__PlanPath_FeedbackMessage;

// Struct for a sequence of kompass_interfaces__action__PlanPath_FeedbackMessage.
typedef struct kompass_interfaces__action__PlanPath_FeedbackMessage__Sequence
{
  kompass_interfaces__action__PlanPath_FeedbackMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__PlanPath_FeedbackMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // KOMPASS_INTERFACES__ACTION__DETAIL__PLAN_PATH__STRUCT_H_
